using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CompeEngineWrapper;

namespace CompeEngineSDKDemoPPC {
    public partial class CompeSDKDemoPPC:Form {
        private CompeGPSEngine engine;
        private CompeEngineWrapper.PaintEventHandler paintEvent;
        private bool panning = true;
        private bool paint = false;
        private bool centerToIt = true;
        private int gpsId = 0;
        private Telemetry telemetry;
        private Telemetry telemetry2;
        private Telemetry[] telemetryArray = new Telemetry[2];

        public CompeSDKDemoPPC() {
            InitializeComponent();
            this.lblStatus.Text = "Compe GPS Engine Initializated";
            try {
                engine = new CompeGPSEngine();
            } catch (CompeGPSEngineException exception) {
                MessageBox.Show(exception.InnerException.Message);
                MessageBox.Show(exception.InnerException.StackTrace);
                this.lblStatus.Text = exception.Message;
                this.lblStatus.Text += exception.InnerException.Message;
                return;
            }
            this.panelCompeEngine.Paint += new System.Windows.Forms.PaintEventHandler(this.panelCompeEngine_Paint);
            //engine.ExecuteCommand(CompeGPSEngineCommand.Command_View_Panning);
            panning = true;
            engine.Invalidate += new CompeEngineWrapper.InvalidateEventHandler(this.engine_Invalidate);
            this.engine.MapPositionTrackingMode = MapPositionTrackingModes.ViewFront;
            //this.engine.ExecuteCommand(CompeGPSEngineCommand.Map_Center_GPS_ViewFront);
            //this.engine.ExecuteCommand(CompeGPSEngineCommand.Command_Autozoom);
            this.engine.AutoZoomEnable();
            paintEvent = new CompeEngineWrapper.PaintEventHandler(this.engine_Paint);
            
            
            // Test UTM2LatLong
            GeoPosition geoPositionUTM = new GeoPosition();
            geoPositionUTM.Easting = 402502;
            geoPositionUTM.Northing = 4701947;
            geoPositionUTM.Zone="31T";
            geoPositionUTM.ConvertUTM2LatLon();

            // Test LatLong2UTM
            GeoPosition geoPosition = new GeoPosition();
            geoPosition.Latitude = 42.4813398;
            geoPosition.Longitude = 1.7464149;
            geoPosition.ConvertLatLon2UTM();

            //Test Distance GeoPosition
            GeoPosition geoPosition2 = new GeoPosition();
            geoPosition2.Latitude = 42.4411956;
            geoPosition2.Longitude = 1.8283029;

            double distancia2=geoPosition.Distance(geoPosition2, CompeGPSEngineDistanceAlgorithm.ALGDIST_ELIPSOIDE_WGS84);

            telemetry = new Telemetry();
            telemetry.Altitude = 0;
            telemetry.Latitude = 42.4867813;
            telemetry.Longitude = 1.7627839;
            telemetry.MagneticCourse = 1;
            telemetry.Speed = 0;
            telemetryArray[0] = telemetry;

            telemetry = new Telemetry();
            telemetry.Altitude = 0;
            telemetry.Latitude = 42.4455261;
            telemetry.Longitude = 1.7868888;
            telemetry.MagneticCourse = 1;
            telemetry.Speed = 0;

            telemetryArray[1] = telemetry;

            // Prova AddMovingItem
            int nmov = this.engine.AddMovingItem("Prueba");
            int nmov1 = this.engine.AddMovingItem("Prueba2");
            int numItems = this.engine.GetNumberMovingItems(); 

            telemetry2 = new Telemetry();
            telemetry2.Altitude = 0;
            telemetry2.Latitude = 42.4637329;
            telemetry2.Longitude = 1.8141006;
            telemetry2.MagneticCourse = 1;
            telemetry2.Speed = 0;
        }
        private void panelCompeEngine_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
            IntPtr hdc = e.Graphics.GetHdc();
            engine.Paint(this.panelCompeEngine.Handle, hdc, this.panelCompeEngine.Height, this.panelCompeEngine.Width);
            e.Graphics.ReleaseHdc(hdc);
        }
        private void engine_Invalidate() {
            this.lblStatus.Text = "Zoom: " + this.engine.MapZoomLvl.ToString("0.###") + "%" +
                        " Rotation:" + this.engine.MapRotation.ToString("0.###") + "" +
                        " " + this.engine.MapViewMode.ToString() +
                        " 3D:" + this.engine.Map3DViewAngle.ToString("0.###") + "" +
                        " " + this.engine.MapPositionTrackingMode.ToString();

                        

            this.panelCompeEngine.Invalidate();
        }
        private void engine_Paint(CompeGraphics graphics, GeoPosition dispTopLeft, GeoPosition dispBottomRight, double angle) {
            //ejemplos para pintar en pantalla
            Pen redPen = new Pen(Color.Red);
            Pen aquaPen = new Pen(Color.Aqua);
            Pen blueVioletPen = new Pen(Color.BlueViolet);
            Pen brownPen = new Pen(Color.Brown);
            Pen cyanPen = new Pen(Color.Cyan);
            graphics.DrawLine(redPen, 10, 10, 600, 300);
            graphics.SetPixel(250, 250, redPen);
            graphics.SetPixel(251, 250, redPen);
            graphics.SetPixel(252, 250, redPen);
            graphics.SetPixel(253, 250, redPen);
            graphics.LineAlpha(20, 20, 400, 300, 50, aquaPen);
            graphics.Circle(300, 100, 20, aquaPen);
            graphics.Rectangle(22, 1, 42, 60, redPen);
            graphics.EmptyRectangle(1, 20, 1, 60, blueVioletPen);
            graphics.Cross(500, 100, 50, brownPen);
            graphics.BitmapPainting("symbols\\10.bmp", 50, 50);
            graphics.SolidCircle(500, 100, 10, cyanPen);
            graphics.Arc(100, 200, 200, 300, 100, 200, 200, 100, cyanPen);
            graphics.DoubleArrow(250, 350, 350, 450, 50, 30, false, blueVioletPen);
            graphics.Arrow(550, 50, 150, 50, 50, 30, false, 200, 200, cyanPen);
            graphics.Elipse(100, 1, 200, 2, blueVioletPen);
            graphics.RoundedRectangle(700, 600, 100, 200, 50, redPen);
            graphics.AlphaRectangle(700, 600, 300, 500, 50, cyanPen);
        }
        private void toolBar_ButtonClick(object sender, ToolBarButtonClickEventArgs e) {
         
            if (e.Button == btnOpenMap) {
                if (openMap.ShowDialog() == DialogResult.OK) {
                    String[] files = new String[1];
                    files[0] = openMap.FileName;
                    engine.OpenFile(files);
                    this.lblStatus.Text = "Files oppened";
                } else {
                    this.lblStatus.Text = "No files selected to open";
                }
                this.engine_Invalidate();
            } else if (e.Button == btnActivateGPS) {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Command_GPS_Activate);
                this.lblStatus.Text = "Connecting GPS";
            } else if (e.Button == btnChangeViewMode) {
                if (panning) {
                    //engine.ExecuteCommand(CompeGPSEngineCommand.Command_View_Rotating3D);
                    this.lblStatus.Text = "Rotate mode activated";
                } else {
                    //engine.ExecuteCommand(CompeGPSEngineCommand.Command_View_Panning);
                    this.lblStatus.Text = "Panning mode activated";
                }
                panning = !panning;
            } else if (e.Button == btn3D) {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Command_Change_3D_View_Mode);
                this.engine_Invalidate();
            } else if (e.Button == btnZoomIn) {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Map_Zoom_Increase);
                this.engine_Invalidate(); ;
            } else if (e.Button == btnZoomOut) {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Map_Zoom_Decrease);
                this.engine_Invalidate();
            } else if (e.Button == btnOpenWPT){
                //Revisar!!!!
                //engine.ExecuteCommand(CompeGPSEngineCommand.Command_Open_Wpt);
            }
            else if (e.Button == btnCloseAll)
            {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Command_Close_All);
            }
            else if (e.Button  == btnNight)
            {
                //engine.ExecuteCommand(CompeGPSEngineCommand.Command_NightVision);           
                this.lblStatus.Text = "Night Vision Activate";
                this.engine_Invalidate();
            }else if (e.Button == btnPaint) {
                if (!paint) {
                    this.engine.PaintAfter += paintEvent;
                } else{
                    this.engine.PaintAfter -=  paintEvent;
                }
                paint = !paint;
                this.engine_Invalidate();
            }
            else if (e.Button == btnTelemetry)
            {
                this.lblStatus.Text = "Test telemetry.";
                bool sortida = engine.LoadTelemetryHistory(telemetryArray, centerToIt, gpsId);
                bool sortida1 = engine.ReportTelemetry(telemetry2, centerToIt, 2);
                this.engine_Invalidate();
            } else if (e.Button == this.btnTests) {
                //this.engine.PanMap(3, -1);
                //this.engine.MapViewMode = MapViewModes.View3D;
                //this.engine.Map3DViewAngle = 45;
                //this.engine.MapZoomLvl = 0.1;
                //this.engine.MapPositionTrackingMode = MapPositionTrackingModes.Center;
                GeoPosition geoPosition = new GeoPosition();
                geoPosition.Latitude = 42.4813398;
                geoPosition.Longitude = 1.7464149;
                this.engine.CenterMapTo(geoPosition);
                this.engine_Invalidate();
            }
        }
        private void CompeSDKDemoPPC_MouseMove(object sender, MouseEventArgs e) {
            if (this.engine != null)
                this.engine.MouseMove(e.X, e.Y);
        }
        private void CompeSDKDemoPPC_MouseDown(object sender, MouseEventArgs e) {
            if (this.engine == null) return;
            MouseButton button = MouseButton.Right;
            if (e.Button == MouseButtons.Left) {
                button = MouseButton.Left;
            }
            this.engine.MouseDown(e.X, e.Y, button);
            this.engine_Invalidate();
        }
        private void CompeSDKDemoPPC_MouseUp(object sender, MouseEventArgs e) {
            if (this.engine == null) return;
            this.engine.MouseUp(e.X, e.Y);
            this.engine_Invalidate();
        }
        /*
        private void CompeSDKDemoPPC_MouseWheel(object sender, MouseEventArgs e) {
            if (this.engine != null) {
                this.engine.MouseWheel(e.X, e.Y, e.Delta);
                this.engine_Invalidate();
            }
        }
         * */
        private void timer1_Tick(object sender, EventArgs e) {
            this.engine_Invalidate();
        }
    }
}